Description

=begin

This case seems to occur whenever

the string begins with a newline, and

the last line doesn't end in whitespace (except, perhaps, newlines), and

the second line (after the initial whitespace) begins with more whitespace than some later line

Here are a couple example strings:

"\n a\nb"

"\n a\n  b\nc"

"\n  a\n b"

YAML::load throws an ArgumentError with a syntax error on the line that begins with less leading

whitespace.

YAML.load YAML.dump("\n a\nb") #=> ArgumentError: syntax error on line 3, col 0: `b'

YAML.load YAML.dump("\n a\n  b\nc") #=> ArgumentError: syntax error on line 4, col 0: `c'

YAML.load YAML.dump("\n  a\n b") #=> ArgumentError: syntax error on line 3, col 1: ` b'

This has been observed in ruby-1.8.6p0 and ruby-1.8.7p0.

Here is another observation of this same bug: 

http://blog.smartlogicsolutions.com/2008/09/04/ruby-patch-to-fix-broken-yamldump-for-multi-line-strings-stringto_yaml/

=end

Related issues:

Is duplicate of Ruby - Bug #2767: YAML bug Closed 02/20/2010

History

#1 - 03/24/2009 05:15 AM - rampion (Noah Easterly)

=begin

Correction: should read "the second line (after the initial newline)"

=end

#2 - 03/25/2009 09:54 PM - daz (Dave B)

- File syck_scan_scalar.patch added

- File test_yaml.patch added

=begin

Good reports, thanks.

I've found a workaround but I'm not sure enough about the YAML spec to guarantee that it's the correct fix.

The patch is mild - it just forces one style over another in the same way as the existing code and allows the new tests to pass along with the rest.

Two patches to 1.9.2dev - these files don't change often ;)
?CHANGELOG: Wed Mar 25 20:06:10 2009  Dave B daz@d10.karoo.co.uk

* ext/syck/emitter.c:  Set SCAN_WHITEEDGE flag when

scalar begins with newline [ruby-core:23006][Bug #1311]

        * test/yaml/test_yaml.rb: add new tests and comment old

          Test::Unit::TestSuite code to enable them to run as $0

 =end

#3 - 09/30/2009 02:23 AM - coatl (caleb clausen)

- File test_yaml2.patch added

- File syck_scan_scalar2.patch added

=begin

I have also been bitten by this same bug. In addition to the cases described above, this problem also occurs when the input contains just a single

newline (in either unix or dos style). The patch supplied by Dave B fixes the case of a string containing just a single unix newline, but fails to fix a

string with just a single dos newline (and probably the other cases initially reported, if the unix newlines are converted to dos newlines). I'm attaching

slightly a slightly modified patches, which addresses the dos newline issue, and tests single dos and unix newlines.

This problem also occurs in ruby 1.9.

=end

#4 - 11/13/2009 06:11 AM - daz (Dave B)

=begin

Caleb's revisions are the way to go.

( test_yaml2.patch & syck_scan_scalar2.patch )

Harmlessly beneficial - no compatibility issues - emits YAML to the spec.

daz

=end

#5 - 03/19/2010 09:02 PM - weppos (Simone Carletti)

- File yaml-error.txt added

=begin

Here's an other test case for a similar issue.

require 'yaml'

c = File.read("yaml-error.txt")

YAML.load(YAML.dump(c))

'rgumentError: syntax error on line 34, col 0: --    from /Users/weppos/.rvm/ruby-1.8.7-p248/lib/ruby/1.8/yaml.rb:133:in load'

from /Users/weppos/.rvm/ruby-1.8.7-p248/lib/ruby/1.8/yaml.rb:133:in `load'

from (irb):3

=end

#6 - 04/09/2010 01:41 AM - mame (Yusuke Endoh)

- Status changed from Open to Closed

=begin

Hi,

Syck is deprecated, in effect.  This issue won't be fixed.

Instead, try Psych.  [ruby-core:29337]

--

Yusuke Endoh mame@tsg.ne.jp

=end

#7 - 04/10/2010 01:54 AM - coatl (caleb clausen)

=begin

Yusuke Endoh and I have verified that all of the test cases reported here are fixed when using psych. For proof of most, see [ruby-core:29323]. And I

06/15/2025 2/3

mailto:daz@d10.karoo.co.uk
bugs.ruby-lang.org/issues/1311
https://bugs.ruby-lang.org/issues/1311
https://blade.ruby-lang.org/ruby-core/29337
mailto:mame@tsg.ne.jp
https://blade.ruby-lang.org/ruby-core/29323


just now verified the last test case is now ok, submitted by Simone Carletti. (No console dump, sorry.)

=end

#8 - 05/03/2010 08:15 AM - nobu (Nobuyoshi Nakada)

- Status changed from Closed to Open

=begin

=end

#9 - 05/03/2010 08:17 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

=begin

This issue was solved with changeset r27591.

Noah, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

=end

Files

syck_scan_scalar.patch 497 Bytes 03/25/2009 daz (Dave B)

test_yaml.patch 1.32 KB 03/25/2009 daz (Dave B)

test_yaml2.patch 1.42 KB 09/30/2009 coatl (caleb clausen)

syck_scan_scalar2.patch 540 Bytes 09/30/2009 coatl (caleb clausen)

yaml-error.txt 1.43 KB 03/19/2010 weppos (Simone Carletti)
